﻿#region Using directives

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Xml;
using System.IO;

#endregion

namespace SLIRN
{
    partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // if get name is clicked...
        private void buttonGetName_Click(object sender, EventArgs e)
        {
            labelInfo.Text = "Getting name..."; // WHY DOES THIS NOT HAPPEN?!
            labelHTML.Text = "";
            string SoapAction = "SOAPACTION: \"urn:schemas-upnp-org:service:AudioIn:1#GetAudioInputName\"";
            string Data =
                "<s:Envelope s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\" xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">"
                +"    <s:Body>"
                +"        <u:GetAudioInputName xmlns:u=\"urn:schemas-upnp-org:service:AudioIn:1\" />"
                +"    </s:Body>"
                +"</s:Envelope>";
            string name = LineInName(SoapAction, Data);

            // if error, display, otherwise show line-in name
            if (name.Substring(0, 6) == "ERROR:")
            {
                labelHTML.Text = name;
                labelInfo.Text = "Error.";
            } else {
                labelInfo.Text = "Got name.";
                textBoxName.Text = name;
            }
        }

        // if set name is clicked...
        private void buttonSetName_Click(object sender, EventArgs e)
        {
            labelInfo.Text = "Setting name...";
            labelHTML.Text = "";
            string SoapAction = "SOAPACTION: \"urn:schemas-upnp-org:service:AudioIn:1#SetAudioInputName\"";
            string Data =
                "<s:Envelope s:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\" xmlns:s=\"http://schemas.xmlsoap.org/soap/envelope/\">"
                +"    <s:Body>"
                +"        <u:SetAudioInputName xmlns:u=\"urn:schemas-upnp-org:service:AudioIn:1\">"
                +"            <DesiredName>" + textBoxName.Text + "</DesiredName>"
                +"        </u:SetAudioInputName>"
                +"    </s:Body>"
                +"</s:Envelope>";
            string name = LineInName(SoapAction, Data);

            // if error, display, otherwise show set name
            if (name.Substring(0, 6) == "ERROR: ")
            {
                labelHTML.Text = name;
                labelInfo.Text = "Error.";
            } else {
                labelInfo.Text = "Set name.";
            }
        }

        // this object does the hard work. talking to ZP, performing action.
        public string LineInName(string SoapAction, string Data)
        {
            //why is this code here? i do not know. it was in the example.
            //probably resets the connection or something.
            System.Net.WebResponse response = null;

            try
            {
                //get zp ip... or use my default
                // TODO: check for correct IP format
                string ip = textBoxIP.Text;
                if (ip == "") ip = "10.0.1.136";

                //connect to zoneplayer
                System.Net.WebRequest request = System.Net.WebRequest.Create("http://" + ip + ":1400/AudioIn/Control");
                request.Method = "POST";
                request.ContentType = "text/xml ; charset=\"utf-8\"";
                request.Timeout = 90000; //timeout. make larger if you don't go through.
                request.Headers.Add(SoapAction); //tells the ZP whether we're setting or getting a name.
                byte[] bytes = System.Text.Encoding.ASCII.GetBytes(Data);
                request.ContentLength = bytes.Length;
                Stream outputStream = request.GetRequestStream();
                outputStream.Write(bytes, 0, bytes.Length);

                //get response from http server (aka zoneplayer). dunno what most of this does.
                response = request.GetResponse();
                System.IO.Stream streamReceive = response.GetResponseStream();
                System.Text.Encoding encoding = System.Text.Encoding.GetEncoding("utf-8");
                System.IO.StreamReader streamRead = new System.IO.StreamReader(streamReceive, encoding);

                //return xml response to a nice variable
                string returnedXml = streamRead.ReadToEnd();
                
                //find "currentname" in returned xml
                int CurrentNameStart = returnedXml.IndexOf("<CurrentName>") + 13;
                int CurrentNameEnd = returnedXml.IndexOf("</CurrentName>");
                string name;
                if (CurrentNameEnd != 0 && CurrentNameStart != 0) //should check for both variables. get an error when i do "var1 && var2" :(
                {
                    name = returnedXml.Substring(CurrentNameStart, (CurrentNameEnd - CurrentNameStart));
                } else {
                    name = "ERROR: Could not get CurrentName.";
                }

                //return xml for debug info. probably get rid of this or hide it later.
                labelHTML.Text = returnedXml;

                return name;
            }
            catch (Exception ex)
            {
                //if error, give feedback. 
                return "ERROR: " + ex.Message;
            }
            finally
            {
                //not sure what this does either. closes connection to http server probably.
                if (response != null)
                {
                    response.Close();
                }
            }
        }
    }
}